void mouse_interact(float X_axis, float Y_axis, float Z_axis, 
float X_ori, float Y_ori, float Z_ori, float pred, color ori_color) {
  float mouseObjectDistance = 
  sq(mouseX-screenX(X_axis, Y_axis, Z_axis))+sq(mouseY-screenY(X_axis, Y_axis, Z_axis)); 
      if (mouseObjectDistance < 20){ 
        pushMatrix();
        fill(ori_color);
        translate(-40, 80);
        textSize(30);
        scale(0.1);
        text("(" + "Counts of Pictures: "+ nf(X_ori,0,0) + ", " +
        "Profile Visits: " + nf(Y_ori,0,0) + ", " + 
        "Counts of Fans: " + nf(Z_ori,0,0) + ", " + 
        "Predicted Value:" +  nf(pred, 0, 0) + ")",
        0,0);
        popMatrix();
        stroke(255);
      } 
      else{
        stroke(ori_color);
      }
}
      
      
void draw_total_label(color mycolor, int posx, int posy, int posz, String label){
  pushMatrix();
  fill(mycolor);
  translate(posx, posy, posz);
  textSize(30);
  scale(0.1);
  text(label, 0,0,0);
  popMatrix();
}

void draw_operation_label(){

String a = "Use the first bottom to go to the Neural Network world";
String b = "Use the second bottom to go to the Linear Regression world";
String c = "Use the third bottom to go to the XGBoost world";
String d = "Use the first slider to slow/fast the rate for Linear Regression";
String e = "Use the second slider to slow/fast the rate for Neural Network"; 
String f = "Press r to see the residuals for all";
textSize(40);
pushMatrix();
fill(#346888);
translate(-110,85,0);
scale(0.1);
text(a, 0,0,0);
popMatrix();


pushMatrix();
fill(#ffa600);
translate(-110,90,0);
scale(0.1);
text(b, 0,0,0);
popMatrix();

pushMatrix();
fill(#7a5195);
translate(-110,95,0);
scale(0.1);
text(c, 0,0,0);
popMatrix();

pushMatrix();
fill(#ffa600);
translate(-110,100,0);
scale(0.1);
text(d, 0,0,0);
popMatrix();

pushMatrix();
fill(#346888);
translate(-110,105,0);
scale(0.1);
text(e, 0,0,0);
popMatrix();

pushMatrix();
fill(#ef5675);
translate(-110,110,0);
scale(0.1);
text(f, 0,0,0);
popMatrix();
}
